//---------------------------------------------------------------------------
//  CheckConnection Component   (c)Kwok Ho Yin, 1998
//
//  Verion: 1.0
//  Date:   25th, Dec., 1998
//
//---------------------------------------------------------------------------
#ifndef CheckConnectionH
#define CheckConnectionH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

typedef void __fastcall (__closure *TConnectedEvent) (TObject *Sender, char *name);
typedef void __fastcall (__closure *TDisconnectedEvent) (TObject *Sender, char *name);

//---------------------------------------------------------------------------

class TAboutClass : public TPersistent
{
private:
    TComponent  *FOwner;

public:
    String  value;
    virtual __fastcall TAboutClass(TComponent *Owner) : TPersistent() {FOwner = Owner;}
};

class PACKAGE TCheckConnection : public TComponent
{
private:
    int                 FInterval;
    bool                FEnabled;
    HWND                FWindowHandle;
    bool                ConnectedFlag;
    bool                NeedUpdateFlag;
    char                ConnectedName[256];
    TAboutClass         *FAbout;

    TConnectedEvent     FOnConnected;
    TDisconnectedEvent  FOnDisconnected;

    void __fastcall UpdateTimer(void);
    void __fastcall SetEnabled(bool flag);
    void __fastcall SetInterval(int value);
    void __fastcall Loaded(void);

protected:

    void __fastcall WndProc(TMessage &Msg);
    void __fastcall Checking(void);

public:
    __fastcall TCheckConnection(TComponent* Owner);
    __fastcall ~TCheckConnection();

__published:
    __property TAboutClass* About = {read=FAbout, write=FAbout};
    __property bool Enabled = {read=FEnabled, write=SetEnabled};
    __property int Interval = {read=FInterval, write=SetInterval};

    __property TConnectedEvent OnConnected = {read=FOnConnected, write=FOnConnected};
    __property TDisconnectedEvent OnDisconnected = {read=FOnDisconnected, write=FOnDisconnected};

};
//---------------------------------------------------------------------------
#endif
