// DirectoryBrowse.cpp: implementation of the CDirectoryBrowse class.
//
// Author:	Bill Oatman
// Version:	1.0
// WebPage:	http://www.netacc.net/~waterbry/dirbrowse/dirbrowse.htm
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirBrowse.h"
#include "DirectoryBrowse.h"
#include <shlobj.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDirectoryBrowse::CDirectoryBrowse()
{
	m_title = "Select Directory";
	m_directory = "";
}

CDirectoryBrowse::~CDirectoryBrowse()
{

}

void CDirectoryBrowse::SetTitle(char *title)
{
	m_title = title;
}

bool CDirectoryBrowse::DoModal()
{
	BROWSEINFO bi;
	char DirName[MAX_PATH];
	int imageIndex = 0;
	LPITEMIDLIST pidl;
    LPMALLOC pmalloc = NULL;

	SHGetMalloc(&pmalloc);

	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = DirName;
	bi.lpszTitle = (LPCTSTR)m_title;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = NULL;
	bi.lParam = NULL;
	bi.iImage = imageIndex;

	pidl = SHBrowseForFolder(&bi);

	if(pidl)
	{
		SHGetPathFromIDList(pidl, DirName);
		m_directory = DirName;
		pmalloc->Free(pidl);
	}

	pmalloc->Release();

	if(pidl)
		return TRUE;
	else
		return FALSE;
}

void CDirectoryBrowse::GetDirectory(CString & directory)
{
	directory = m_directory;
}
